N=10;
te=0.9028;
tc=0.1166;
del=0.1041;
mut1=0.3299;
mut2=0.3299;
munt=7.2691;
nt1=4; nt2=7;

%hamiltonian
[ca,cc] = creationoperators(2*N);
[hmut1,hmut2,hmunt,ht1,htnt,ht2,hd,hu]=kitaevchain_3segments_hamiltonian_7param(N,nt1,nt2,cc,ca);
h=mut1*hmut1+mut2*hmut2+munt*hmunt+te*ht1+te*ht2+tc*htnt+del*hd;

g=gammamatrices(2*N);
g5 =(1i^N)*(eye(2^N));%create gamma5 operator for parity check
for i= 1:2*N
g5 = g5*g{i};
end

U=0.25:0.0001:0.5;
s=size(U,2);
xe=zeros(2,s);
yo=zeros(2,s);

for j=1:s
hf=h+U(1,j)*hu;
e=eig(hf);
[eeven,eodd]=evenoddparity(g5,hf,e);
xe(:,j)=eeven;
yo(:,j)=eodd;
end

%% plot energy levels

figure; 
 for i=1:2
  L(1)=plot(U,xe(i,:),'LineWidth',2,'color','r');
hold on
end
 xline(0.3477,'k-.','LineWidth',1)
 for i=1:2
  L(2)=plot(U,yo(i,:),'LineWidth',2,'color','k');
hold on
 end
lgd=legend(L, {'even parity - $E_{\left| 11\right>}, E_{\left| 00 \right>}$', 'odd parity - $E_{\left| 01\right>}, E_{\left| 10 \right>}$'},'Location','northwest','Box','on','linewidth',0.7,'Interpreter','Latex');
grid on
xlabel('U (a.u.)','FontSize',15,'FontWeight','normal');
ylabel('E (a.u.)');
lgd.LineWidth = 0.7;
lgd.FontSize = 12;
ax = gca;
ax.XAxis.FontSize = 18;
ax.YAxis.FontSize = 18;
ax.XAxis.FontWeight = 'bold';
ax.YAxis.FontWeight = 'bold';
ax.GridAlpha = 0.2;
hold off


%% sort energy levels in even and odd parity levels
function[eeven,eodd]=evenoddparity(g5,h,ed)
eeven=zeros(2,1);
eodd=zeros(2,1);
par=zeros(1,4);
[vd,~]=eig(h);
c1=1;
c2=1;
for i=1:4
    p=(vd(:,i)'*g5*vd(:,i))/(sqrt(vd(:,i)'*vd(:,i)));
    par(1,i)=p;
    if (round(p,4)==1)
        eeven(c1,1)=ed(i);
        c1=c1+1;
    elseif(round(p,4)==-1)
        eodd(c2,1)=ed(i);
        c2=c2+1;
    end
end
if(sum(round(par,4))~=0)
    disp('sum parity vec not equals zero')
end
end