
%% parameters at optimal point
N=10;
t=0.4025;
del=0.2167;
mut1=0.4832;
mut2=0.4832;
munt=8.5364;
nt1=4; nt2=7;

%% total hamiltonian
[ca,cc]=creationoperators(2*N);

[hmut1,hmut2,hmunt,ht,hd,~]=kitaevchain_3segments_hamiltonian(N,nt1,nt2,cc,ca);
h=mut1*hmut1+mut2*hmut2+munt*hmunt+t*ht+del*hd;


[vd,~]=eig(h);

%eigenstates 
psi00=vd(:,1);
psi01=vd(:,2);
psi10=vd(:,3);



wf1=zeros(1,2*N);
wf2=zeros(1,2*N);

g=gammamatrices(2*N);

for i=1:2*N
    wf2(1,i)=psi00'*g{i}*psi10/(sqrt((psi00'*psi00)*(psi10'*psi10)));
    wf1(1,i)=psi00'*g{i}*psi01/(sqrt((psi00'*psi00)*(psi01'*psi01)));
end

wfa1=abs(wf1(1:2:end));
wfb1=abs(wf1(2:2:end));
wfa2=abs(wf2(1:2:end));
wfb2=abs(wf2(2:2:end));

%% plot the wavefunctions

figure
plot(wfa1,'-','LineWidth',1.5);
hold on;
plot(wfa1,'.','MarkerSize',10);
plot(wfb1,'-','LineWidth',1.5);
plot(wfb1,'.','MarkerSize',10);
xlim([1,10])

xlabel('site')
ylabel('\gamma_x,\gamma_y')


figure
plot(wfa2,'-','LineWidth',1.5);
hold on;
plot(wfa2,'.','MarkerSize',10);
hold on;
plot(wfb2,'-','LineWidth',1.5);
hold on;
plot(wfb2,'.','MarkerSize',10);
xlim([1,10])

xlabel('site');
ylabel('\gamma_x,\gamma_y');

