tic
N=10;
t=0.4025;
del=0.2167;
mut1=0.4832;
mut2=0.4832;
munt=8.5364;
nt1=4; nt2=7;

U=0:0.01:1;
s=size(U,2);


[ca,cc] = creationoperators(2*N);
g=gammamatrices(2*N);
g5 =(1i^N)*(eye(2^N));
for i= 1:2*N %create gamma5 operator for parity check
g5 = g5*g{i};
end

[hmut1,hmut2,hmunt,ht,hd,hint1,hint2,hint3,hint4]=kitaevchain_hamiltonian_otherinteractions(N,nt1,nt2,cc,ca);
h=mut1*hmut1+mut2*hmut2+munt*hmunt+t*ht+del*hd;


%% h_{int} = U\sum_{i}c_{i}^{\dagger}c_{i}c_{i+1}^{\dagger}c_{i+1}
lambda1=zeros(1,s);
lambda2=zeros(1,s);
u=zeros(1,s);
for j=1:s
hf=h+U(1,j)*hint1;
e=eig(hf);
[evn,odd]=evenoddparity(g5,hf,e,U(1,j));
lambda1(1,j)=(evn(2,1)-evn(1,1)-odd(2,1)+odd(1,1))/4;
lambda2(1,j)=(evn(2,1)-evn(1,1)+odd(2,1)-odd(1,1))/4;
u(1,j)=(evn(2,1)+evn(1,1)-odd(2,1)-odd(1,1))/4;
end

figure;
plot(U,lambda1,'color',[1, 0.65, 0],'LineWidth',2.5);
hold on
plot(U,lambda2,'--','color',[0.0171, 0.3823, 0.6007],'LineWidth',2.5);
hold on
plot(U,u,'-.','color',[0.737,0.314,0.565],'LineWidth',2.5);
grid on
xlabel('$U$ (a.u.)','FontWeight','bold','Interpreter','latex');
ylabel('$E$ (a.u.)','FontWeight','bold','Interpreter','latex');
lgd = legend('\lambda_1','\lambda_2','u');
lgd.LineWidth = 0.7;
lgd.FontSize = 12;
ax = gca;
ax.XAxis.FontSize = 12;
ax.YAxis.FontSize = 12;
ax.XAxis.FontWeight = 'bold';
ax.YAxis.FontWeight = 'bold';   
ax.GridAlpha = 0.2;
hold off




%% h_{int} = U\sum_{i}c_{i}^{\dagger}c_{i}c_{i+2}^{\dagger}c_{i+2}
lambda1=zeros(1,s);
lambda2=zeros(1,s);
u=zeros(1,s);
for j=1:s
hf=h+U(1,j)*hint2;
e=eig(hf);
[evn,odd]=evenoddparity(g5,hf,e,U(1,j));
lambda1(1,j)=(evn(2,1)-evn(1,1)-odd(2,1)+odd(1,1))/4;
lambda2(1,j)=(evn(2,1)-evn(1,1)+odd(2,1)-odd(1,1))/4;
u(1,j)=(evn(2,1)+evn(1,1)-odd(2,1)-odd(1,1))/4;
end

figure;
plot(U,lambda1,'color',[1, 0.65, 0],'LineWidth',2.5);
hold on
plot(U,lambda2,'--','color',[0.0171, 0.3823, 0.6007],'LineWidth',2.5);
hold on
plot(U,u,'-.','color',[0.737,0.314,0.565],'LineWidth',2.5);
grid on
xlabel('$U$ (a.u.)','FontWeight','bold','Interpreter','latex');
ylabel('$E$ (a.u.)','FontWeight','bold','Interpreter','latex');
lgd = legend('\lambda_1','\lambda_2','u');
lgd.LineWidth = 0.7;
lgd.FontSize = 12;
ax = gca;
ax.XAxis.FontSize = 12;
ax.YAxis.FontSize = 12;
ax.XAxis.FontWeight = 'bold';
ax.YAxis.FontWeight = 'bold';   
ax.GridAlpha = 0.2;
hold off

%% h_{int} = U\sum_{i}c_{i}^{\dagger}c_{i}c_{i+3}^{\dagger}c_{i+3}
lambda1=zeros(1,s);
lambda2=zeros(1,s);
u=zeros(1,s);
for j=1:s
hf=h+U(1,j)*hint3;
e=eig(hf);
[evn,odd]=evenoddparity(g5,hf,e,U(1,j));
lambda1(1,j)=(evn(2,1)-evn(1,1)-odd(2,1)+odd(1,1))/4;
lambda2(1,j)=(evn(2,1)-evn(1,1)+odd(2,1)-odd(1,1))/4;
u(1,j)=(evn(2,1)+evn(1,1)-odd(2,1)-odd(1,1))/4;
end

figure;
plot(U,lambda1,'color',[1, 0.65, 0],'LineWidth',2.5);
hold on
plot(U,lambda2,'--','color',[0.0171, 0.3823, 0.6007],'LineWidth',2.5);
hold on
plot(U,u,'-.','color',[0.737,0.314,0.565],'LineWidth',2.5);
grid on
xlabel('$U$ (a.u.)','FontWeight','bold','Interpreter','latex');
ylabel('$E$ (a.u.)','FontWeight','bold','Interpreter','latex');
lgd = legend('\lambda_1','\lambda_2','u');
lgd.LineWidth = 0.7;
lgd.FontSize = 12;
ax = gca;
ax.XAxis.FontSize = 12;
ax.YAxis.FontSize = 12;
ax.XAxis.FontWeight = 'bold';
ax.YAxis.FontWeight = 'bold';   
ax.GridAlpha = 0.2;
hold off

%% h_{int} = U\sum_{i}c_{i}^{\dagger}c_{i}c_{i+4}^{\dagger}c_{i+4}
lambda1=zeros(1,s);
lambda2=zeros(1,s);
u=zeros(1,s);
for j=1:s
hf=h+U(1,j)*hint4;
e=eig(hf);
[evn,odd]=evenoddparity(g5,hf,e,U(1,j));
lambda1(1,j)=(evn(2,1)-evn(1,1)-odd(2,1)+odd(1,1))/4;
lambda2(1,j)=(evn(2,1)-evn(1,1)+odd(2,1)-odd(1,1))/4;
u(1,j)=(evn(2,1)+evn(1,1)-odd(2,1)-odd(1,1))/4;
end

figure;
plot(U,lambda1,'color',[1, 0.65, 0],'LineWidth',2.5);
hold on
plot(U,lambda2,'--','color',[0.0171, 0.3823, 0.6007],'LineWidth',2.5);
hold on
plot(U,u,'-.','color',[0.737,0.314,0.565],'LineWidth',2.5);
grid on
xlabel('$U$ (a.u.)','FontWeight','bold','Interpreter','latex');
ylabel('$E$ (a.u.)','FontWeight','bold','Interpreter','latex');
lgd = legend('\lambda_1','\lambda_2','u');
lgd.LineWidth = 0.7;
lgd.FontSize = 12;
ax = gca;
ax.XAxis.FontSize = 12;
ax.YAxis.FontSize = 12;
ax.XAxis.FontWeight = 'bold';
ax.YAxis.FontWeight = 'bold';   
ax.GridAlpha = 0.2;
hold off


%% sort energy levels in even and odd parity levels
function[eeven,eodd]=evenoddparity(g5,h,ed,U)
eeven=zeros(2,1);
eodd=zeros(2,1);
par=zeros(1,4);
[vd,~]=eig(h);
c1=1;
c2=1;
for i=1:4
    p=(vd(:,i)'*g5*vd(:,i))/(sqrt(vd(:,i)'*vd(:,i)));
    par(1,i)=p;
    if (round(p,4)==1)
        eeven(c1,1)=ed(i);
        c1=c1+1;
    elseif(round(p,4)==-1)
        eodd(c2,1)=ed(i);
        c2=c2+1;
    end
end
if(sum(round(par,4))~=0) %check U is within the valid range
    disp("sum parity vec not equals zero"+"U"+U)
end
end