N=10;
t=0.0144;
del=0.0104;
mut1=0.0100;
mut2=0.0100 ;
mut3=0.0100;
munt1=3.0001;
munt2=3.0001;
nt11=3; nt12=4;
nt21=7; nt22=8;

%hamiltonian
[ca,cc] = creationoperators(2*N);
[hmut1,hmut2,hmut3,hmunt1,hmunt2,ht,hd,hu]=kitaevchain_5segments_hamiltonian(N,nt11,nt12,nt21,nt22,cc,ca);
h=mut1*hmut1+mut2*hmut2+munt1*hmunt1+t*ht+del*hd+munt2*hmunt2+mut3*hmut3;

U=0:0.0001:0.005;
s=size(U,2);
xe=zeros(4,s);
yo=zeros(4,s);

g=gammamatrices(2*N);
g5 =(1i^N)*(eye(2^N));
for i= 1:2*N % create gamma5 operator for parity check
g5 = g5*g{i};
end

for j=1:s
hf=h+U(1,j)*hu;
e=eig(hf);
[eeven,eodd]=evenoddparity(g5,hf,e);
xe(:,j)=eeven;
yo(:,j)=eodd;
end

%% plot energy levels

figure;
 for i=1:4
  L(1)=plot(U,xe(i,:),'LineWidth',2,'color','r');
hold on
 end
 
xline(0.0039,'k-.','LineWidth',2)

 for i=1:4
  L(2)=plot(U,yo(i,:),'LineWidth',2,'color','k');
hold on
 end
lgd=legend(L, {'even parity - $E_{\left| 000 \right>}, E_{\left| 011 \right>}, E_{\left| 101 \right>}, E_{\left| 110 \right>}$', 'odd parity - $E_{\left| 001 \right>}, E_{\left| 010 \right>}, E_{\left| 100 \right>}, E_{\left| 111 \right>}$'},'Location','northwest','Box','on','linewidth',0.7,'Interpreter','Latex');
grid on
xlabel('U (a.u.)','FontSize',15,'FontWeight','normal');
ylabel('E (a.u.)');
lgd.LineWidth = 0.7;
lgd.FontSize = 12;
ax = gca;
ax.XAxis.FontSize = 20;
ax.YAxis.FontSize = 20;
ax.XAxis.FontWeight = 'bold';
ax.YAxis.FontWeight = 'bold';
ax.GridAlpha = 0.2;
hold off


%% check parity
function[eeven,eodd]=evenoddparity(g5,h,ed)
eeven=zeros(4,1);
eodd=zeros(4,1);
par=zeros(1,8);
[vd,~]=eig(h);
c1=1;
c2=1;
for i=1:8
    p=(vd(:,i)'*g5*vd(:,i))/(sqrt(vd(:,i)'*vd(:,i)));
    par(1,i)=p;
    if (round(p,4)==1)
        eeven(c1,1)=ed(i);
        c1=c1+1;
    elseif(round(p,4)==-1)
        eodd(c2,1)=ed(i);
        c2=c2+1;
    end
end
if(sum(round(par,4))~=0)
    disp('sum parity vec not equals zero')
end
end