% parameters
N=10;
nt11=3; nt12=4;
nt21=7; nt22=8;

% hamiltonian
[ca,cc] = creationoperators(2*N);
[hmut1,hmut2,hmut3,hmunt1,hmunt2,ht,hd,hu]=kitaevchain_5segments_hamiltonian(N,nt11,nt12,nt21,nt22,cc,ca);

%search algorithm
rng default
ms = MultiStart('FunctionTolerance',1e-10,'UseParallel',true);
gs = GlobalSearch(ms);
options = optimoptions(@fmincon,'Algorithm','sqp-legacy','MaxIterations',3000);
fun = @(x) egap(hmut1,hmut2,hmut3,hmunt1,hmunt2,ht,hd,x(1),x(2),x(3),x(4),x(5),x(6),x(7));
problem = createOptimProblem('fmincon','x0',[0.1 0.1 0.1 10 10 0.1 0.1],...
    'objective',fun,'lb',[0.01 0.01 0.01 3 3 0.01 0.01],'ub',[0.5 0.5 0.5 10 10 0.1 0.1],'options',options);
[x,fval] = run(gs,problem);

disp("The optimal point is:");
disp(x);

%E_|111>-E_|000> function
function[egap]=egap(hmt1,hmt2,hmt3,hmnt1,hmnt2,ht,hd,mut1,mut2,mut3,munt1,munt2,t,del)
h=mut1*hmt1+mut2*hmt2+munt1*hmnt1+t*ht+del*hd+munt2*hmnt2+mut3*hmt3;
e=eig(h);
egap=e(8)-e(1);
end



