%parameters
N=10;
t=0.1000;
del=0.1315;
mut1=0.5746;
mut2=0.5743;
mut3=0.5746;
munt1=10.0000;
munt2=10.0000;
nt11=3; nt12=4;
nt21=7; nt22=8;

%hamiltonian
[ca,cc] = creationoperators(2*N);
[hmut1,hmut2,hmut3,hmunt1,hmunt2,ht,hd,hu]=kitaevchain_5segments_hamiltonian(N,nt11,nt12,nt21,nt22,cc,ca);
h=mut1*hmut1+mut2*hmut2+munt1*hmunt1+t*ht+del*hd+munt2*hmunt2+mut3*hmut3;

U=0.08:0.001:0.11;
s=size(U,2);

% check parity for U(1,1)  
g=gammamatrices(2*N);
g5 =(1i^N)*(eye(2^N));
for i= 1:2*N % create gamma5 operator for parity check
g5 = g5*g{i};
end
[vd0,eg0]=eigs(h+U(1,1)*hu,8,'sr');
par0=zeros(1,8);
for i=1:8
    p=(vd0(:,i)'*g5*vd0(:,i))/(sqrt(vd0(:,i)'*vd0(:,i)));
    par0(1,i)=round(p,4);
end
if(round(sum(par0),4)~=0)
    disp('total parity non-zero');
end

%% find lambda's, u's, v

hf = zeros(2^N, 2^N, s);
for j=1:s
  hf(:,:,j)=h+U(1,j)*hu;  
end

e = eigenshuffle_modified(hf); %shuffle eigenvalues
ex = flipud(e);
evn=zeros(4,s);
odd=zeros(4,s);
c1=1;
c2=1;
for i=1:8
    if(round(par0(1,i),4)==1)
        evn(c1,:)=ex(i,:);
        c1=c1+1;
    elseif(round(par0(1,i),4)==-1)
        odd(c2,:)=ex(i,:);
        c2=c2+1;
    end
end
       
lambda1=zeros(1,s);
lambda2=zeros(1,s);
lambda3=zeros(1,s);
u1=zeros(1,s);
u2=zeros(1,s);
u3=zeros(1,s);
v=zeros(1,s);

for i=1:s

lambda1(1,i)=(-evn(1,i)-odd(1,i)-odd(2,i)+odd(3,i)-evn(2,i)+evn(3,i)+evn(4,i)+odd(4,i))/8;
lambda2(1,i)=(-evn(1,i)-odd(1,i)+odd(2,i)-odd(3,i)+evn(2,i)-evn(3,i)+evn(4,i)+odd(4,i))/8;
lambda3(1,i)=(-evn(1,i)+odd(1,i)-odd(2,i)-odd(3,i)+evn(2,i)+evn(3,i)-evn(4,i)+odd(4,i))/8;
u1(1,i)=(evn(1,i)+odd(1,i)-odd(2,i)-odd(3,i)-evn(2,i)-evn(3,i)+evn(4,i)+odd(4,i))/8;
u2(1,i)=(evn(1,i)-odd(1,i)+odd(2,i)-odd(3,i)-evn(2,i)+evn(3,i)-evn(4,i)+odd(4,i))/8;
u3(1,i)=(evn(1,i)-odd(1,i)-odd(2,i)+odd(3,i)+evn(2,i)-evn(3,i)-evn(4,i)+odd(4,i))/8;
v(1,i)=(-evn(1,i)+odd(1,i)+odd(2,i)+odd(3,i)-evn(2,i)-evn(3,i)-evn(4,i)+odd(4,i))/8;

end

%% plot figure

figure
hold on
p1=plot(U,lambda1,'s','LineWidth',4,'MarkerSize',2.8);
p2= plot(U,lambda2,'-','LineWidth',3);
p3=plot(U,lambda3,'.','LineWidth',2,'Markersize',8);
p4=plot(U,u1,'d','LineWidth',2,'Markersize',7);  
p5=plot(U,u2,'--','LineWidth',10);
p6=plot(U,u3,'x','LineWidth',1.5);
p7=plot(U,v,'r-.','LineWidth',2);
xline(0.097,'k:','LineWidth',2)
p5.Color=[0.11, 0.62,0.47];
p6.Color=[0.85, 0.37,0.01];
p4.Color=[0.46, 0.44,0.70];
p1.Color=[0.00, 0.25,0.36];
p2.Color=[0.74, 0.31,0.56];
p3.Color=[0.90, 0.67,0.01];

p1.Color(4) = 0.25;
p4.Color(4) = 0.25;
p5.Color(4) = 0.5 ;
p7.Color(4) = 0.85;

grid on
xlabel('U (a.u.)','FontWeight','bold');
ylabel('E (a.u.)','FontWeight','bold');
lgd = legend('\lambda_1','\lambda_2','\lambda_3','u_1','u_2','u_3','v');
lgd.LineWidth = 0.7;
lgd.FontSize = 12;
 lgd.Location = 'bestoutside';
ax = gca;
ax.XAxis.FontSize = 18;
ax.YAxis.FontSize = 18;
ax.XAxis.FontWeight = 'bold';
ax.YAxis.FontWeight = 'bold';   
ax.GridAlpha = 0.2;
box on
hold off
