
 j1234=-1:0.1:1;
 s=size(j1234,2);
 xe=zeros(2,s);
 yo=zeros(2,s);
 N=4;
 kij=0; %all kij are equal valued here
 
for i=1:s

[hamil,egn] = twocomplexfermion_hamiltonian(j1234(1,i),kij,kij,kij,kij,kij,kij);

[eodd,eeven]=graphhfblk_parity(hamil);
    if(size(eeven,1)<2)
        eeven=[eeven' zeros(1,2-size(eeven,1))];
        eeven=sort(eeven)';
    end
    xe(:,i)=eeven;
    if(size(eodd,1)<2)
        eodd=[eodd' zeros(1,2-size(eodd,1))];
        eodd=sort(eodd)';
    end
    yo(:,i)=eodd;
end

%% plot energy levels vs j1234 (kij fixed)

figure
 for i=1:2
  L(1)=plot(j1234,xe(i,:),'LineWidth',2,'color','r');
hold on
end


 for i=1:2
  L(2)=plot(j1234,yo(i,:),'LineWidth',2,'color','k');
hold on
 end
legend(L, {'even parity', 'odd parity'},'Location','northeast','Box','on','linewidth',0.7,'fontsize',12)
lgd=legend(L, {'even parity - $E_{\left| 11\right>}, E_{\left| 00 \right>}$', 'odd parity - $E_{\left| 01\right>}, E_{\left| 10 \right>}$'},'Location','northeast','Box','on','linewidth',0.8,'Interpreter','Latex');
lgd.LineWidth = 0.8;
lgd.FontSize = 14;
ylabel('E (a.u.)','FontSize',24);
% xlabel('K_{ij} (a.u.)','FontSize',24);
xlabel('J_{1234} (a.u.)','FontSize',24);
grid on

ax = gca;
Fontsize = 20;
xlFontsize=20;
xl = get(gca,'XLabel');
xlFontSize = get(xl,'FontSize');
xAX = get(gca,'XAxis');
set(xAX,'FontSize', Fontsize)
set(xl, 'FontSize', xlFontSize);
yl = get(gca,'YLabel');
ylFontSize = get(yl,'FontSize');
yAX = get(gca,'YAxis');
set(yAX,'FontSize', Fontsize)
set(yl, 'FontSize', xlFontSize);
ax.XAxis.FontWeight = 'bold';
ax.YAxis.FontWeight = 'bold';
ax.GridAlpha = 0.2;
hold off;

%% sort energy levels by parity

function[eodd,eeven]=graphhfblk_parity(hf)
g=gammamatrices(4);
g5 = (1i^(2))*(eye(4));
for i= 1:4
g5 = g5*g{i};
end
hamile = 0.5 * hf *(eye(4)+g5);
ex=eig(hamile);
eeven=ex(abs(ex) >= 1e-10);
hamilo = 0.5 * hf *(eye(4)-g5);
ex=eig(hamilo);
eodd=ex(abs(ex) >= 1e-10);
end


